MODULE GraphicsDemoII;

(* Dieses Demo veranschaulicht die Benutzung der Grafikbefehle aus  *)
(* dem Modul Graphicssupport. Auf diesem Demo liegt kein Copyright! *)

FROM SYSTEM          IMPORT ADR,ASSEMBLE,ADDRESS;
FROM GraphicsSupport IMPORT GetView,ViewHandlePtr,MakePlayfield,MoveView,
                            pXOverscan,pYOverscan,GetPattern,FreePattern,
                            Spline,Rect,InitSArea,SAreaMove,SAreaDraw,SetView,
                            SAreaEllipse,SAreaEnd,SAreaHandlePtr,SAreaEndFlag,
                            FreeView,Line,WriteText,Fill,FillMode,
                            SetViewPosition,GetBitMap,GetRastPort,FreeBitMap,
                            FreeRastPort,MovePlayfield,TurtleHandlePtr,
                            InitTurtleGraphics,FreeTurtleGraphics,Home,
                            Left,Right,Forward,Backward,PenUp,PenDown,
                            TurtleCursor,playfield,SetPlayfieldPriority,
                            SetTurtleRast,
                            pink,forestgreen,bordeaux,gold,skyblue,
                            lightbrown,nightblue,darkbrown,violet,lightgrey;
FROM GraphicsL       IMPORT SetAPen,SetRast,RectFill,WaitTOF,SetDrMd;
FROM GraphicsD       IMPORT ViewModes,ViewModeSet,RastPortPtr,BitMapPtr,jam1;
FROM GfxMacros       IMPORT SetAfPen,SetOPen,DrawCircle;
FROM RandomNumber    IMPORT RND;
FROM DosL            IMPORT Delay;


(*$ EntryExitCode:=FALSE *)
PROCEDURE Colors;
BEGIN
  ASSEMBLE(
    DC.W $0000,$0FFF,$0F00,$0F0F,$0FF0,$00FF,$00F0,$000F
    DC.W $0F82,$02F8,$082F,$0F28,$0F55,$0666,$0999,$0CCC
    DC.W $0982,$0289,$0394,pink,forestgreen,bordeaux,gold,skyblue
    DC.W lightbrown,nightblue,darkbrown,violet,$0444,$0777,$0AAA,lightgrey
  END);
END Colors;


(*$ EntryExitCode:=FALSE *)
PROCEDURE Pattern; (* Jede Zahl reprsentiert die Farbe eines Pixels *)
BEGIN
  ASSEMBLE(
    DC.B  1,23,22,21,20,19,11,10, 9, 8, 7, 6, 5, 4, 3, 2
    DC.B  2, 1,23,22,21,20,19,11,10, 9, 8, 7, 6, 5, 4, 3
    DC.B  3, 2, 1,23,22,21,20,19,11,10, 9, 8, 7, 6, 5, 4
    DC.B  4, 3, 2, 1,23,22,21,20,19,11,10, 9, 8, 7, 6, 5
    DC.B  5, 4, 3, 2, 1,23,22,21,20,19,11,10, 9, 8, 7, 6
    DC.B  6, 5, 4, 3, 2, 1,23,22,21,20,19,11,10, 9, 8, 7
    DC.B  7, 6, 5, 4, 3, 2, 1,23,22,21,20,19,11,10, 9, 8
    DC.B  8, 7, 6, 5, 4, 3, 2, 1,23,22,21,20,19,11,10, 9
    DC.B  9, 8, 7, 6, 5, 4, 3, 2, 1,23,22,21,20,19,11,10
    DC.B 10, 9, 8, 7, 6, 5, 4, 3, 2, 1,23,22,21,20,19,11
    DC.B 11,10, 9, 8, 7, 6, 5, 4, 3, 2, 1,23,22,21,20,19
    DC.B 19,11,10, 9, 8, 7, 6, 5, 4, 3, 2, 1,23,22,21,20
    DC.B 20,19,11,10, 9, 8, 7, 6, 5, 4, 3, 2, 1,23,22,21
    DC.B 21,20,19,11,10, 9, 8, 7, 6, 5, 4, 3, 2, 1,23,22
    DC.B 22,21,20,19,11,10, 9, 8, 7, 6, 5, 4, 3, 2, 1,23
    DC.B 23,22,21,20,19,11,10, 9, 8, 7, 6, 5, 4, 3, 2, 1
  END);
END Pattern;



PROCEDURE ZeichneBaum(t : TurtleHandlePtr;
                      l : INTEGER);
BEGIN
  l:=l*7/10;

  Left(t,30);
  Forward(t,l);
  IF l>3 THEN
    ZeichneBaum(t,l);
  END;

  PenUp(t);
  Backward(t,l);
  PenDown(t);

  Right(t,60);
  Forward(t,l);
  IF l>3 THEN
    ZeichneBaum(t,l);
  END;

  PenUp(t);
  Backward(t,l);
  PenDown(t);

  Left(t,30);
END ZeichneBaum;



VAR vh        : ViewHandlePtr;
    rp,rp2    : RastPortPtr;
    bm        : BitMapPtr;
    sa        : SAreaHandlePtr;
    pat       : ADDRESS;
    t,u,g,x,y : INTEGER;
    tg        : TurtleHandlePtr;

BEGIN

  vh:=GetView(350,280,5,ViewModeSet{},ADR(Colors));
  IF vh#NIL THEN
    SetViewPosition(vh,pXOverscan,pYOverscan); (* Overscanmodus *)
    SetView(vh);

    rp:=ADR(vh^.rastPort);

    WriteText(rp, 10,10, 1, "Spline - Demo");  (* Kurvendemo *)
    FOR u:=0 TO 5 DO
      FOR t:=1 TO 31 DO
        SetAPen(rp,t);
        Spline(rp,RND(350),RND(280),RND(350),RND(280),RND(350),RND(280),
                  RND(350),RND(280),16);
      END;
    END;

    Delay(100);

    SetRast(rp,0);

    WriteText(rp, 10,10, 1, "Rect - Demo");  (* Boxdemo *)
    FOR u:=0 TO 5 DO
      FOR t:=1 TO 31 DO
        Rect(rp,RND(350),RND(280),RND(350),RND(280),t);
      END;
    END;

    Delay(100);

    SetRast(rp,0);

    WriteText(rp, 10,10, 1, "Line - Demo"); (* Liniendemo *)
    FOR u:=0 TO 5 DO
      FOR t:=1 TO 31 DO
        Line(rp,RND(350),RND(280),RND(350),RND(280),t);
      END;
    END;

    Delay(100);

    FOR g:=0 TO 1 DO
      SetRast(rp,0);   (* Flchenfllerdemo *)
      IF g=0 THEN
        WriteText(rp, 10,10, 1, "Areaoutline - Demo");
      ELSE
        WriteText(rp, 10,10, 1, "Area - Demo");
      END;
      FOR u:=0 TO 63 DO
        sa:=InitSArea(rp,32);
        SetAPen(rp,u MOD 32); SetOPen(rp,31-(u MOD 32));
        SAreaMove(sa,RND(350),RND(280));
        FOR t:=0 TO 1 DO
          SAreaDraw(sa,RND(350),RND(280));
        END;
        IF g=0 THEN
          SAreaEnd(sa,aOutline);
        ELSE
          SAreaEnd(sa,aSolid);
        END;
      END;

      Delay(100);
    END;

    tg:=InitTurtleGraphics(rp);
    IF tg#NIL THEN
      FOR g:=0 TO 1 DO
        SetTurtleRast(tg,0);
        IF g=0 THEN
          WriteText(rp, 10,10, 1, "Turtle-Grafik mit Cursor");

          FOR t:=0 TO 360 DO  (* einmal rotieren *)
            Left(tg,1);
          END;
        ELSE
          WriteText(rp, 10,10, 1, "Das gleiche ohne Cursor!");
        END;

        Home(tg);

        PenUp(tg);
        Backward(tg,100);
        PenDown(tg);

        Forward(tg,40);
        ZeichneBaum(tg,80);  (* Rekursiver Aufruf! *)

        TurtleCursor(tg,FALSE);
        Delay(100);

      END;
      FreeTurtleGraphics(tg);
    END;

    pat:=GetPattern(ADR(Pattern),5,16);  (* Fllmuster berechnen *)
    IF pat#NIL THEN
      SetAfPen(rp,pat,-4);  (* Multicolor-Fllmuster der Hhe *)
                            (* 2^4=16 einsetzen.              *)
      FOR t:=0 TO 1 DO
        SetRast(rp,0); SetAPen(rp,1);
        IF t=0 THEN
          WriteText(rp, 10,10, 1, "Fill (sameColor) - Demo");
        ELSE
          WriteText(rp, 10,10, 1, "Fill (outline) - Demo");
        END;

        SetAPen(rp,2);
        DrawCircle(rp,75,140,70);
        DrawCircle(rp,275,140,70);
        DrawCircle(rp,175,40,35);
        DrawCircle(rp,175,240,35);

        SetAPen(rp,1);
        DrawCircle(rp,175,140,100);
        SetAPen(rp,31);
        IF t=0 THEN
          Fill(rp,fSameColor,175,140,1);
        ELSE
          Fill(rp,fOutline,175,140,1);
        END;
        Delay(100);
      END;
      FreePattern(pat);
      SetAfPen(rp,NIL,0);
    END;
  END;

  IF vh#NIL THEN FreeView(vh); END;

  bm:=GetBitMap(640,400,3); (* 2. Bitmap fr Dual-Playfield *)

  IF bm#NIL THEN
    rp2:=GetRastPort(bm); (* RastPort zum zeichnen auf Dual-Playfield *)
    IF rp2#NIL THEN

      FOR x:=0 TO 31 DO
        FOR y:=0 TO 19 DO (* Rechtecke zeichnen *)
          SetAPen(rp2,((x+(y*31)) MOD 8)+8);
          RectFill(rp2,x*20+2,y*20+2,x*20+17,y*20+17);
          SetAPen(rp2,((x+(y*31)+1) MOD 8)+8);
          RectFill(rp2,x*20+6,y*20+6,x*20+13,y*20+13);
          SetAPen(rp2,0);
          RectFill(rp2,x*20+8,y*20+8,x*20+11,y*20+11);
        END;
      END;

      vh:=GetView(640,400,3,ViewModeSet{dualpf},ADR(Colors));
      IF vh#NIL THEN
        SetViewPosition(vh,pXOverscan,pYOverscan);
        (* Overscan-Scrolling flimmert am rechten Rand! *)

        SetView(vh);

        MakePlayfield(vh,bm);

        rp:=ADR(vh^.rastPort);
        SetDrMd(rp,jam1);
        FOR t:=0 TO 200 DO
          WriteText(rp, RND(600), RND(370)+16, RND(7)+1, "Demo");
        END;

        FOR y:=0 TO 1 DO
          FOR t:=1 TO -1 BY -2 DO
            FOR x:=0 TO 150 DO
              MoveView(vh,2*t,0);      (* Scrollen *)
              MovePlayfield(vh,0,1*t);
              WaitTOF;                 (* Warten auf Rasterstrahl *)
              SetView(vh);             (* Bild neu anzeigen       *)
            END;
            FOR x:=0 TO 150 DO
              MoveView(vh,0,1*t);
              MovePlayfield(vh,2*t,0);
              WaitTOF;
              SetView(vh);
            END;
          END;
          SetPlayfieldPriority(vh,playfield);
          (* Das hintere Playfield wird nach vorne geholt *)
        END;
      END;
    END;
  END;

CLOSE

  FreeTurtleGraphics(tg);
  FreeView(vh);
  FreeBitMap(bm);
  FreePattern(pat);
  FreeRastPort(rp2);

END GraphicsDemoII.
